unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, PerfMon;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    PerformanceGraphic1: TPerformanceGraphic;
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure UpdateProcessor(Sender: TObject; Lines: TLineItems);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  ComboBox1.ItemIndex := Ord(PerformanceGraphic1.UpdateSpeed);
  SpinEdit1.Value := PerformanceGraphic1.GridWidth;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  PerformanceGraphic1.UpdateSpeed := TEnumSpeed(ComboBox1.ItemIndex);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  PerformanceGraphic1.GridWidth := SpinEdit1.Value;
end;

procedure TForm1.UpdateProcessor(Sender: TObject; Lines: TLineItems);

  procedure UpdateItem(ItemIndex: Integer);
  var
    X: Integer;
  begin
    X := (ItemIndex + 1) * 10;
    if Random(100) > 85 then Inc(X, -10 + Random(20));
    with Lines.ItemByName [ Format('Line %d', [ItemIndex] ) ] do
      Value[Count] := X;
  end;

var
  I: Integer;
begin
  for I := 0 to Lines.Count - 1 do
    UpdateItem ( I + 1 );
end;

initialization
  Randomize;
end.
